/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
**
** Copyright 2008 Tim Johansson.  All rights reserved.
**
*/

#ifndef KOMCHANGEPRESENTATION_H
#define KOMCHANGEPRESENTATION_H

#include "komclient.h"

/** Command to change the presentation of a conference or user. */
class KOMChangePresentationCommand : public KOMCommand
{
public:
	KOMChangePresentationCommand(KOMCommandListener* l, int sid, KOMSession* kom) : KOMCommand(l, sid, kom){}
	virtual ~KOMChangePresentationCommand() {}
	virtual int Construct(KOMString& cmd);
	virtual bool progress(KOMString& reply);

	static const char* const commandString;
private:
	int cmdID;
	int confNum;
	int presentationConf;
	KOMString name;
	int oldTextNum;
	KOMString presentation;
	bool person;
	enum {KOM_PRES_CHECK_OLD, KOM_PRES_CHECK_CONF, KOM_PRES_CREATE_TEXT, KOM_PRES_SET_PRES} state;
};

#endif // KOMCHANGEPRESENTATION_H

