/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
**
** Copyright 2008 Tim Johansson.  All rights reserved.
**
*/

#ifndef KOMCONFINFO_H
#define KOMCONFINFO_H

#include "komclient.h"

/** Command to get all information of a conference. */
class KOMConferenceInfoCommand : public KOMCommand
{
public:
	KOMConferenceInfoCommand(KOMCommandListener* l, int sid, KOMSession* kom) : KOMCommand(l, sid, kom){}
	virtual ~KOMConferenceInfoCommand() {}
	virtual int Construct(KOMString& cmd);
	virtual bool progress(KOMString& reply);

	static const char* const commandString;
private:
	void sendOk(KOMString& userListReply);
	int cmdID;
	int confNum;
	int supervisor;
	int presentationNum;
	bool presentationUTF8;
	bool presentationReformat;
	int numMembers;
	unsigned int confType;
	enum {CONF_INFO_STAT, CONF_INFO_PRESENTATION_STAT, CONF_INFO_PRESENTATION, CONF_INFO_USERLIST} state;
};

#endif // KOMCONFINFO_H

