/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
**
** Copyright 2008 Tim Johansson.  All rights reserved.
**
*/

#ifndef KOMCREATECONF_H
#define KOMCREATECONF_H

#include "komclient.h"

/** Command to create a new conference. */
class KOMCreateConferenceCommand : public KOMCommand
{
public:
	KOMCreateConferenceCommand(KOMCommandListener* l, int sid, KOMSession* kom) : KOMCommand(l, sid, kom){}
	virtual ~KOMCreateConferenceCommand() {}
	virtual int Construct(KOMString& cmd);
	virtual bool progress(KOMString& reply);

	static const char* const commandString;
private:
	int cmdID;
};

/** Command to change the type of a conference. */
class KOMChangeConferenceTypeCommand : public KOMCommand
{
public:
	KOMChangeConferenceTypeCommand(KOMCommandListener* l, int sid, KOMSession* kom) : KOMCommand(l, sid, kom){}
	virtual ~KOMChangeConferenceTypeCommand() {}
	virtual int Construct(KOMString& cmd);
	virtual bool progress(KOMString& reply);

	static const char* const commandString;
private:
	int cmdID;
};

/** Command to rename a conference. */
class KOMRenameConferenceCommand : public KOMCommand
{
public:
	KOMRenameConferenceCommand(KOMCommandListener* l, int sid, KOMSession* kom) : KOMCommand(l, sid, kom){}
	virtual ~KOMRenameConferenceCommand() {}
	virtual int Construct(KOMString& cmd);
	virtual bool progress(KOMString& reply);

	static const char* const commandString;
private:
	int cmdID;
};

/** Command to rename a conference. */
class KOMChangeSupervisorCommand : public KOMCommand
{
public:
	KOMChangeSupervisorCommand(KOMCommandListener* l, int sid, KOMSession* kom) : KOMCommand(l, sid, kom){}
	virtual ~KOMChangeSupervisorCommand() {}
	virtual int Construct(KOMString& cmd);
	virtual bool progress(KOMString& reply);

	static const char* const commandString;
private:
	int cmdID;
};



#endif // KOMCREATECONF_H

