/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
**
** Copyright 2009 Tim Johansson.  All rights reserved.
**
*/

#ifndef KOMFAVORITES_H
#define KOMFAVORITES_H

#include "komclient.h"

/** Command to change the favorite status of a text. */
class KOMSetFavoriteCommand : public KOMCommand
{
public:
	KOMSetFavoriteCommand(KOMCommandListener* l, int sid, KOMSession* kom) : KOMCommand(l, sid, kom){}
	virtual ~KOMSetFavoriteCommand() {}
	virtual int Construct(KOMString& cmd);
	virtual bool progress(KOMString& reply);

	static const char* const commandString;
private:
	int cmdID;
	int textNum;
	int markType;
};

class KOMListFavoritesCommand: public KOMCommand
{
public:
	KOMListFavoritesCommand(KOMCommandListener* l, int sid, KOMSession* kom) : KOMCommand(l, sid, kom), numFavorites(0), favorites(NULL){}
	virtual ~KOMListFavoritesCommand()
	{
		delete[] favorites;
	}
	virtual int Construct(KOMString& cmd);
	virtual bool progress(KOMString& reply);

	static const char* const commandString;
private:
	void sendReply();
	int cmdID;

	int numFavorites;
	int numRequests;
	struct KOMFav
	{
		int statCmd;
		int textCmd;
		int textNum;
		int markType;
	};
	KOMFav* favorites;
};

#endif // KOMFAVORITES_H

