/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
**
** Copyright 2008 Tim Johansson.  All rights reserved.
**
*/

#ifndef KOMLISTALLCONF_H
#define KOMLISTALLCONF_H

#include "komclient.h"

/** Command to list all conferences of a specified type (users or conferences) */
class KOMListAllConferencesCommand : public KOMCommand
{
public:
	KOMListAllConferencesCommand(KOMCommandListener* l, int sid, KOMSession* kom) : KOMCommand(l, sid, kom){}
	virtual ~KOMListAllConferencesCommand();
	virtual int Construct(KOMString& cmd);
	virtual bool progress(KOMString& reply);

	static const char* const commandString;
private:
	int cmdID;
};

/** Command to list all online users. */
class KOMListAllOnlineUsersCommand : public KOMCommand
{
public:
	KOMListAllOnlineUsersCommand(KOMCommandListener* l, int sid, KOMSession* kom) : KOMCommand(l, sid, kom){}
	virtual ~KOMListAllOnlineUsersCommand();
	virtual int Construct(KOMString& cmd);
	virtual bool progress(KOMString& reply);

	static const char* const commandString;
private:
	int cmdID;
};

#endif // KOMLISTALLCONF_H

