/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
**
** Copyright 2008 Tim Johansson.  All rights reserved.
**
*/

#ifndef KOMLISTMESSAGES_H
#define KOMLISTMESSAGES_H

#include "komclient.h"

class KOMListMessagesCommand : public KOMCommand
{
public:
	KOMListMessagesCommand(KOMCommandListener* l, int sid, KOMSession* kom) : KOMCommand(l, sid, kom), requests(NULL){}
	virtual ~KOMListMessagesCommand();
	virtual int Construct(KOMString& cmd);
	virtual bool progress(KOMString& reply);

	static const char* const commandString;
private:
	struct MessageRequest
	{
		int cmdId;
		int textNum;
		bool stat;
		MessageRequest* next;
	};
	void findRootText();
	void sendTextRequests();
	void progressStat(KOMString& re, bool is_ok, MessageRequest* req);
	void progressText(KOMString& re, bool is_ok, MessageRequest* req);
	void sendReply();
	int conferenceNum;

	MessageRequest* requests;
	int numRequests;
	int baseTextNum;

	int rootTextRequest;
	int requestedRootNum;
	int requestedBaseTextNum;
};

#endif // KOMLISTMESSAGES_H

