/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
**
** Copyright 2008 Tim Johansson.  All rights reserved.
**
*/

#ifndef KOMLISTSUBCONF_H
#define KOMLISTSUBCONF_H

#include "komclient.h"

class KOMListSubscribedConferencesCommand : public KOMCommand
{
public:
	KOMListSubscribedConferencesCommand(KOMCommandListener* l, int sid, KOMSession* kom) : KOMCommand(l, sid, kom), numConfRequests(0), confRequests(NULL){}
	virtual ~KOMListSubscribedConferencesCommand();
	virtual int Construct(KOMString& cmd);
	virtual bool progress(KOMString& reply);

	static const char* const commandString;
private:
	bool progressConfList(int id, KOMString& re, bool is_ok);
	bool progressConfName(int id, KOMString& re, bool is_ok);
	bool progressConfMessageList(int id, KOMString& re, bool is_ok);
	bool progressUnread(int id, KOMString& re, bool is_ok);
	bool progressVerifyUnread(int id, KOMString& re, bool is_ok);
	void verifyUnread(int confNum = -1);

	int listCmdId;
	int unreadCmdId;

	int numConfRequests;
	int* confRequests;
	enum{UPDATE_CONF_LIST, UPDATE_CONF_NAME, UPDATE_CONF_UNREAD, UPDATE_CONF_MESSAGE_LIST, UPDATE_CONF_VERIFY_UNREAD} status;
};

#endif // KOMLISTSUBCONF_H

