/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
**
** Copyright 2008 Tim Johansson.  All rights reserved.
**
*/

#ifndef KOMLISTTHREADS_H
#define KOMLISTTHREADS_H

#include "komclient.h"

class KOMListThreadsCommand : public KOMCommand
{
public:
	KOMListThreadsCommand(KOMCommandListener* l, int sid, KOMSession* kom) : KOMCommand(l, sid, kom), locToGlobCmdId(-1), maxRequests(0), activeRequests(0), requests(NULL), conf(NULL){}
	virtual ~KOMListThreadsCommand();
	virtual int Construct(KOMString& cmd);
	virtual bool progress(KOMString& reply);

	static const char* const commandString;
private:
	bool progressLocToGlob(KOMString& re, bool is_ok);
	bool progressStat(KOMString& re, int id, bool is_ok);
	void sendReply();
	void sendStatRequests();
	void sendTitleRequests();

	int locToGlobCmdId;

	struct TextRequest
	{
		int cmdId;
		int reqTextNum;
		int baseLocalNum;
	};
	int maxRequests;
	int activeRequests;
	TextRequest* requests;
	int currentText;
	int newestLocal;
	int firstReqLocToGlob;

	KOMConferenceStat* conf;

	int firstThread;
	int numThreads;

	KOMHash threads;
};

#endif // KOMLISTTHREADS_H

