/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
**
** Copyright 2008 Tim Johansson.  All rights reserved.
**
*/

#ifndef KOMLOGIN_H
#define KOMLOGIN_H

#include "komclient.h"

/** Login command. COnnects to a server and logs in a user. */
class KOMLoginCommand : public KOMCommand
{
public:
	KOMLoginCommand(KOMCommandListener* l, int sid, KOMSession* kom) : KOMCommand(l, sid, kom) {}
	virtual ~KOMLoginCommand() {}
	virtual int Construct(KOMString& cmd);
	virtual bool progress(KOMString& reply);
private:
	enum {LOGIN_CONNECT, LOGIN_LOOKUP_USER, LOGIN_CREATE_USER, LOGIN_LOGIN, LOGIN_ACCEPT_ASYNC, LOGIN_CHECK_VERSION, LOGIN_SET_CLIENT, LOGIN_SET_UTC, LOGIN_INIT_FAVORITE_CACHE} state;
	KOMString user;
	KOMString passwd;
	int createNew;
	int userID;
	int cmdID;
};

#endif // KOMLOGIN_H

