/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
**
** Copyright 2009 Tim Johansson.  All rights reserved.
**
*/

#ifndef KOMLOOKUPNAME_H
#define KOMLOOKUPNAME_H

#include "komclient.h"

/** Command to lookup a name (users or conferences) from an id. */
class KOMLookupNameFromIDCommand : public KOMCommand
{
public:
	KOMLookupNameFromIDCommand(KOMCommandListener* l, int sid, KOMSession* kom) : KOMCommand(l, sid, kom){}
	virtual ~KOMLookupNameFromIDCommand();
	virtual int Construct(KOMString& cmd);
	virtual bool progress(KOMString& reply);

	static const char* const commandString;
private:
	int cmdID;
	int conf;
};

class KOMListCachedNamesCommand : public KOMCommand
{
public:
	KOMListCachedNamesCommand(KOMCommandListener* l, int sid, KOMSession* kom) : KOMCommand(l, sid, kom){}
	virtual ~KOMListCachedNamesCommand(){}
	virtual int Construct(KOMString& cmd);
	virtual bool progress(KOMString& reply){return false;}

	static const char* const commandString;
};

class KOMPrefetchNamesCommand : public KOMCommand
{
public:
	KOMPrefetchNamesCommand(KOMCommandListener* l, int sid, KOMSession* kom) : KOMCommand(l, sid, kom), requests(NULL){}
	virtual ~KOMPrefetchNamesCommand();
	virtual int Construct(KOMString& cmd);
	virtual bool progress(KOMString& reply);

	static const char* const commandString;
private:
	struct PFReq
	{
		int reqId;
		int confId;
		PFReq* next;
	};

	PFReq* requests;
	unsigned int activeRequests;
};

#endif // KOMLOOKUPNAME_H

