/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
**
** Copyright 2008 Tim Johansson.  All rights reserved.
**
*/

#ifndef KOMMARKREAD_H
#define KOMMARKREAD_H

#include "komclient.h"

/** COmmand to send an instant message to a user or conference. */
class KOMMarkReadCommand : public KOMCommand
{
public:
	KOMMarkReadCommand(KOMCommandListener* l, int sid, KOMSession* kom) : KOMCommand(l, sid, kom){}
	virtual ~KOMMarkReadCommand() {}
	virtual int Construct(KOMString& cmd);
	virtual bool progress(KOMString& reply);

	static const char* const commandString;
private:
	struct MarkConfCmd
	{
		int cmdID;
		int confNum;
		int textNum;
		struct MarkConfCmd* next;
	};
	int cmdID;
	int confNum;
	int textNum;
	bool mark_all;
	MarkConfCmd* pendingCmds;
};

class KOMIgnoreThreadCommand : public KOMCommand
{
public:
	KOMIgnoreThreadCommand(KOMCommandListener* l, int sid, KOMSession* kom) : KOMCommand(l, sid, kom){}
	virtual ~KOMIgnoreThreadCommand() {}
	virtual int Construct(KOMString& cmd);
	virtual bool progress(KOMString& reply){return false;}

	static const char* const commandString;
};

#endif // KOMMARKREAD_H

