/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
**
** Copyright 2008 Tim Johansson.  All rights reserved.
**
*/

#ifndef KOMSENDMSG_H
#define KOMSENDMSG_H

#include "komclient.h"

/** Command to send a message to a user or conference, including replying to messages. */
class KOMSendMsgCommand : public KOMCommand
{
public:
	KOMSendMsgCommand(KOMCommandListener* l, int sid, KOMSession* kom) : KOMCommand(l, sid, kom), replyTo(-1) {}
	virtual ~KOMSendMsgCommand() {}
	virtual int Construct(KOMString& cmd);
	virtual bool progress(KOMString& reply);

	static const char* const commandString;
private:
	int cmdID;
	int replyTo;
	KOMString text;
	int firstSubConf;
};

/** Command to send a message to a user or conference, including replying to messages. */
class KOMGetReplyRecptCommand : public KOMCommand
{
public:
	KOMGetReplyRecptCommand(KOMCommandListener* l, int sid, KOMSession* kom) : KOMCommand(l, sid, kom), to(NULL) {}
	virtual ~KOMGetReplyRecptCommand() {delete[] to;}
	virtual int Construct(KOMString& cmd);
	virtual bool progress(KOMString& reply);

	static const char* const commandString;
private:
	void toListFinished();
	struct Recpt
	{
		int conf;
		int cmdId;
	};
	Recpt* to;
	int numTo;
	int pendingCmds;
	int from;
	int fromCmd;
	bool toModified;
	bool toSelf;
};

#endif // KOMSENDMSG_H

