#ifndef MACTRAYICON_H
#define MACTRAYICON_H

#include "trayicon.h"

typedef struct objc_object *id;
void SystemOpenURL(const char* url);

class MacTrayIcon : public TrayIcon
{
public:
	MacTrayIcon(TrayIconListener* l);
	virtual ~MacTrayIcon();
	
	virtual int addIcon(void* icon);
	virtual int setActiveIcon(int iconId);
	virtual int show(int vis);
	virtual void clearPopupMenu();
	virtual int addPopupMenuItem(const char* text, int id, bool def);
	
	bool handleEvent(void* evt);
	int getSystemSocket();
private:
	TrayIconListener* listener;
	struct TrayPopupMenuItem
	{
		char* text;
		int id;
		bool def;
		void* instance;
		TrayPopupMenuItem* next;
	};
	TrayPopupMenuItem* popupMenu;
	char** icons;
	unsigned int numIcons;
	unsigned int activeIcon;
	bool isVisible;
	
	id macStatusBar;
};

#endif // !MACTRAYICON_H
