#ifndef WIN32TRAYICON_H
#define WIN32TRAYICON_H

#include "trayicon.h"

#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#define MAX_ICONS 16

class Win32TrayIcon : public TrayIcon
{
public:
	Win32TrayIcon(HWND w, TrayIconListener* l);
	virtual ~Win32TrayIcon();

	virtual int addIcon(void* icon);
	virtual int setActiveIcon(int iconId);
	virtual int show(int vis);

	virtual void clearPopupMenu();
	virtual int addPopupMenuItem(const char* text, int id, bool def);

	int handleEvent(UINT msg, WPARAM wParam, LPARAM lParam);
private:
	HWND win;
	HICON bitmaps[MAX_ICONS];
	int numBitmaps;
	int currentBitmap;
	bool isVisible;
	TrayIconListener* listener;
	struct TrayPopupMenuItem
	{
		wchar_t* text;
		int id;
		bool def;
		TrayPopupMenuItem* next;
	};
	TrayPopupMenuItem* popupMenu;
};

#endif // TRAYICON_H

