#ifndef X11TRAYICON_H
#define X11TRAYICON_H

#include <X11/Xlib.h>
#include "trayicon.h"

#define MAX_ICONS 16

class X11TrayIcon : public TrayIcon
{
public:
	X11TrayIcon(Display* d, TrayIconListener* l);
	virtual ~X11TrayIcon();

	virtual int addIcon(void* icon);
	virtual int setActiveIcon(int iconId);
	virtual int show(int vis);
	virtual void clearPopupMenu();
	virtual int addPopupMenuItem(const char* text, int id, bool def);

	int handleEvent(const XEvent& e);
private:
	int createWindow();
	int requestDock();
	int sendTrayMessage(long message, long data1 = 0, long data2 = 0, long data3 = 0);

	void createPopupWindow(int x, int y);
	void closePopupWindow();

	void repaintIcon();

	Display* disp;
	Window win;
	GC gc;
	int width;
	int height;
	double lastClick;

	Pixmap bitmaps[MAX_ICONS];
	Pixmap masks[MAX_ICONS];
	int numBitmaps;
	int currentBitmap;
	bool isVisible;

	TrayIconListener* listener;

	Window popup_win;
	GC popup_gc;
	int popup_font_ascent;
	int popup_font_descent;
	int popup_width;
	int popup_height;

	struct TrayPopupMenuItem
	{
		char* text;
		int id;
		bool def;
		TrayPopupMenuItem* next;
	};
	TrayPopupMenuItem* popupMenu;
};

#endif // X11TRAYICON_H

