/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
**
** Copyright 2010 Tim Johansson.  All rights reserved.
**
*/

#ifndef VERSIONCHECKER_H
#define VERSIONCHECKER_H

#include "../komstring.h"

// Required socket includes
#ifdef WIN32
#include <winsock.h>
#define close(s) closesocket(s)
#define socket_errno WSAGetLastError()
#define EAGAIN WSAEWOULDBLOCK
#define EINPROGRESS WSAEINPROGRESS
#define UINT32 unsigned long
#define WM_SOCKET WM_USER
extern HWND g_win;
#else // !WIN32
#include <sys/socket.h>
#include <sys/un.h>
#include <netinet/in.h>
#include <netdb.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <errno.h>
#define socket_errno errno
#define UINT32 u_int32_t
#endif // !WIN32

class VersionChecker
{
public:
	VersionChecker();
	~VersionChecker();

	void sendRequest();
	void processData();
	void disconnect();

	const char* getUpgradeMessage(){return message;}
	int getCurrentSocket(){return socket;}
private:
	struct sockaddr_in versrvaddr;
	bool connecting;

	int socket;
	KOMString reply;
	int contentLen;

	const char* message;
};

#endif // VERSIONCHECKER_H
